#ifndef __OBJMANAGER_H__
#define __OBJMANAGER_H__

#include <neurocad/module.h>

typedef struct __object {
	long hmem;			//memory handle
	long oid;			//object id
	size_t hard_names, soft_names;	//amount of hard and soft names
	datum *data;			//object data pointer
	size_t datasize;		//size of object data
	module *blocks;			//linked list of object blocks
	size_t blocksize;		//counter of oall blocks inserted in linked list
	struct __object *next;		//pointer to next object
} object;

typedef object *obp;

extern void *memory_heandle;
extern obp obj_root;
extern obp obj_curr;
extern long int obj_number;

long	obj_add( long oid );
int	obj_inithd( unsigned long all_names, size_t all_block_size );
int	obj_releasehd( void );
obp	obj_find( long oid );
long	obj_setactive( long oid );

int	obj_test( long oid );
int	obj_testall( void );

datum	obj_getdata( long oid, size_t nid );
int	obj_setdata( long oid, size_t nid, datum value );
datum	obj_getbuffer( long oid, size_t nid, int shift );
datum	*obj_getdatapointer( long oid, size_t nid);

int	obj_printinfo( void );
#endif
