#ifndef __ASMMANAGER_H__
#define __ASMMANAGER_H__

/**
asm_init() attachs `assname' library as assembler part of engine.
If library needs some initiated procedure use function _init() as standart
library way.
**/
int asm_init(const char *assname);

/**
(*asm_model_grow)() is function of an assembler library called by simmanager in
every step of simulation. Use it for growing neuralnetwork, blasting 
neuralnetwork, etc.
**/
extern int (*asm_model_grow_pointer)();

/** 
(*asm_messenger)() is function of an assembler library called by libnce for translation
same message from engine to assmebler. The paramter of function is a code of assembler
message Assembler can use engine context `extern nce_context engine_context' define in 
nce_common.h for access to binary and text input - output stream
**/
extern int (*asm_messenger_pointer)(int asm_command, int command_length);

/**
(*asm_printinfo)() is function of an assembler library called by libnce for
printing out the condition of assembler
**/
extern int (*asm_printinfo_pointer)();

/**
asm_drop() detaches assembler library. If library uses dynamical memory or similar and
needs same destroy procedure use standart library function _fini().
**/
int asm_drop();
#endif
