#ifndef _ASMBASIC_H_
#define _ASMBASIC_H_

#include <neurocad/engine/libnce.h>


#ifdef __HAS_CONFIG__
	#include "../config.h"
#else
	#ifndef __APPLICATION__
		#define __APPLICATION__			"neurocad"
	#endif
	
	#ifndef __APP_VERSION__
		#define __APP_VERSION__			"0.00"
	#endif
	
	#ifndef __MOD_FORMAT_VERSION__
		#define __MOD_FORMAT_VERSION__		"0.1"
	#endif

	#ifndef __RDWR_BUFFER_SIZE__
		#define __RDWR_BUFFER_SIZE__		4096
	#endif

	#ifndef __MEMPAGE_SIZE__
		#define __MEMPAGE_SIZE__		4096
	#endif
#endif

enum __asmbasec_returns{
	ASMBASIC_RET_DATA_GET = NCE_RET_SEPARATOR,
	ASMBASIC_RET_DATA_GET_BUFFER,
	ASMBASIC_RET_WATCHER_ITEM_ADD_ID,
	ASMBASIC_RET_SEPARATOR
};

enum __asmbasec_commands {
//Manipulation with model
	ASMBASIC_MODEL_UPLOAD = NCE_SEPARATOR,
	ASMBASIC_MODEL_REINIT,
	ASMBASIC_MODEL_RELEASE,
	ASMBASIC_MODEL_DESTROY,
	ASMBASIC_MODEL_SAVE,
	ASMBASIC_MODEL_RESTORE,
//Data manipulation
	ASMBASIC_DATA_GET,
	ASMBASIC_DATA_SET,
	ASMBASIC_DATA_GET_BUFFER,
//Data Watcher (stream data ....) commands
	ASMBASIC_WATCHER_ADD_ITEM,
	ASMBASIC_WATCHER_ADD_ITEM_MIN,
	ASMBASIC_WATCHER_ADD_ITEM_MAX,
	ASMBASIC_WATCHER_ADD_ITEM_AVERAGE,
	ASMBASIC_WATCHER_KILL_ITEM,
//Commands for information and engine testing
	ASMBASIC_PRINT_INFO,
	ASMBASIC_PRINT_INFO_PARSER,
	ASMBASIC_PRINT_INFO_OBJECTS,
//Set the enum of server commands or upper programme in
	ASMBASIC_SEPARATOR
};

extern int asm_messenger(int model_command, int command_length);
extern int asm_model_grow();
extern int asm_printinfo();

#endif
