#ifndef __MODMANAGER_H__
#define __MODMANAGER_H__
#include <neurocad/module.h>

extern int mod_number;
/**

**/
typedef struct __moditem {
	enum __mt type;
	enum __ml multiload;
	int mid;
	int names;
	int iterations;
	int priority;
	int overstep;
	int blocksize;
	double weight;
	char *filename;
	char **parvar;
	module *(*modadd)( int, module *, void *);
	int (*calculate)( int );
	int (*slack)( int );
	int (*jump)( int );
	int (*restore)(int, int, int, int );
	int (*save)(int, int, int, int );
	void *hmod;
	struct __moditem *next;
} moditem;

typedef moditem * mip; //module item poiter

/**
**/
int mod_insert(char *mod_file_name, int mid);

/**
**/
int mod_insert_empty(int mid);

/**
**/
int mod_remove(int mid);

/**
**/
int mod_removeall();


/**
**/
int mod_get_number();

/**
**/
mip mod_get_item(int mid);

/**
**/
mip mod_get_list();

/**
**/
int mod_init(int mid);

/**
**/
int mod_free(int mid);

/**
**/
int mod_is_acctive(int mid);


/**
**/
int mod_set_extended_attribute(int mid, char *name, char *value);

/**
**/
int mod_flash_extended_attribute(int mid);


/**
**/
int mod_printinfo();
#endif

