#ifndef __SIMMANAGER_H__
#define __SIMMANAGER_H__
#include <unistd.h>
#include <signal.h>

#include <neurocad/module.h>
#include <neurocad/engine/modmanager.h>
#include  <neurocad/engine/watchmanager.h>

extern double time_cur, time_step;
extern int _sw, _asw, _bufdeep;
extern sig_atomic_t sim_flag;

int sim_init();
int sim_free();
int sim_step();

int sim_start(double continueTime);
int sim_go(int numberSteps);
int sim_until(double untilTime);
int sim_stop();

int sim_db_iter();
int sim_db_mod_iter(int mid);
int sim_db_next_mod_iter();


int sim_printinfo();

#endif
