#ifndef __WATCHMANAGER_H__
#define __WATCHMANAGER_H__

#include <sys/uio.h>
#include <neurocad/engine/nce_common.h>
/**
watch() is function called in every step of simulation for
stream output watcherd data
**/
void watch();

/**
watcher_restart() restarts watcher. Use it then `time_step' is 
changed.
**/
void watcher_restart();

/**
function watcher_add() creat new watcher. Return watcher ID (wid) 
if succesfule and number under zero otherwise.
**/
int watcher_add(int ifd,double period);

/**
watcher_kill() kills watcher with ID `wid'. Retunr 0 or error code.
**/
int watcher_kill(int wid);

/**
watcher_killall() kills all wathers and cleans watcher list.
**/
int watcher_killall();

/**
watcher_set_mode() sets up mode of wid watcher in `mode'
**/
int watcher_set_mode(int wid, int mode);

/**
watchitem_add() adds new intem of watcherd data for watching
in `wid' watcher. Current watchers item has its own ID in watcher 
striam `id'. Data will be read from `data' pointer.
WARRNING: `data' must be set in the begining _buffdeep area!!!!
Flag item_mode constranes watcher to send average, minima or 
maximal data from period, if item_mode is zero watcher send lastes
value of data.
Returns zero if successful.s
**/
int watchitem_add(int wid, int id, int item_mode, datum *data);

/**
watchitem_kill() kills item `id' from watcher with `wid'
**/
int watchitem_kill(int wid, int id);

/**
watcher_printinfo() prints out information about all watchers
**/
int watcher_printinfo();

#endif
