
#define FTRK(U,TH, A, Q) ((fabs(((U)-(TH))/(Q)) > 1e-6) ? (A) * ((U) - (TH)) / (1 - exp(-((U) - (TH))/(Q))) : (A) * (Q))

#define __ALPHA_M(U) FTRK( ((U)-10.),-35.,0.182,9.)
#define __BETA_M(U)  FTRK(-((U)-10.), 35.,0.124,9.)
#define __POW_M(x) ( (x) * (x) * (x) )

#define __INF_H(U) (1./(1.+exp(((U)+55.)/6.2)))
#define __TAU_H(U) (1./(FTRK(((U)-10.), -50.,0.024,5.)+FTRK(-((U)-10.),75.,0.0091,5.)))

#define __TEMPERATURE_M
#define __TEMPERATURE_H

#define __MOD_NAME "Na Fast channel"
#define __MOD_DESCRIPTION "This module contains the implementation of fast sodium ion channel.\nThe channel description was taken from paper\nMainen Z.K. Sejnowski T.J. Nature v.382 96(model I)with correction from http://senselab.med.yale.edu/senselab/ModelDB/ShowModel.asp?model=2488\nThe channel has activation and inactiovation gate variables.\n"
#include <neurocad/tpl/ion_channel_eulexp.c.tpl>
