
#define __ALPHA_M(U) ((0.05*((U)+34.0))/(1.0-exp(-((U)+34.0)/10.0)))
#define __BETA_M(U)  (0.625 * exp(-( (U) + 44.0 )/80.0))
#define __POW_M(x) ( (x) * (x) * (x) * (x) )
#define __MOD_NAME "Delayed rectifier K channel(Wang and Buzsaki 1996)"
#define __MOD_DESCRIPTION "This module contains the implementation of delayed rectifier potassium channel.\nThe channel description was taken from paper: Wang X-J and Buzsaki G. J.Neurosci 16: 6402 -6413, 1996, republished by A. Compte et al. J.Neurophysiol 89: 2707-2725, 2003.\nThe channel has only activation gate variable.\nThe different equasion are solved by exponentioal Euler method and compatible with compartment/single sell module."
#include <neurocad/tpl/ion_channel_eulexp.c.tpl>
