
#define __ALPHA_M(U) ((0.5*((U)+35.0))/(1-exp(-((U)+35.0)/10.0)))
#define __BETA_M(U)  (20.0 * exp(-( (U) + 60.0 )/18))
#define __ALPHA_H(U) (0.35 * exp(-((U)+58.0)/20.0))
#define __BETA_H(U)  ( 5.0 / (1 + exp(-((U) + 28.0)/10.0)) )
#define __POW_M(x) ( (x) * (x) * (x) )
#define __MOD_NAME "Na Activate/Inactivate channel(Wang and Buzsaki 1996)"
#define __MOD_DESCRIPTION "This module contains the implementation of fast sodium ion channel.\nThe channel description was taken from paper: Wang X-J and Buzsaki G. J.Neurosci 16: 6402 -6413, 1996, republished by A. Compte et al. J.Neurophysiol 89: 2707-2725, 2003.\nThe channel has activation and inactiovation gate variables.\nThe different equasion are solved by exponentioal Euler method and compatible with compartment/single sell module."
#include <neurocad/tpl/ion_channel_eulexp.c.tpl>
