#include <stdio.h>
#include <fcntl.h>

#include "../../src/xmlfn.h"

int usage( void )
{
	return -1;
}

void print_all_props( const char *node_name, int tabs )
{
	int cnt=0;
	for(; cnt < tabs; cnt++) printf("\t");
	printf( "<%s> ==> ", node_name );
	char *prop_val = NULL;
	while( (prop_val = xmlfn_propscan())  != NULL ){
		printf( "%s = ", prop_val );
		printf( "%s   ", xmlfn_propscan_getvalue());
	}
}

char *print_curr_node( void )
{
	char *node_name;
	int tabs= xmlfn_stepin();
	for(node_name = xmlfn_nextnode( NULL ) ; node_name != NULL; node_name = xmlfn_nextnode( NULL ) ){
		print_all_props( node_name, tabs );
		printf("\n");
		print_curr_node();
	}
	xmlfn_stepout( NULL );
	return NULL;
}

void  print_node_name( char * name)
{
	char *node_name;
	int tabs= xmlfn_stepin();
	for(node_name = xmlfn_nextnode( name ) ; node_name != NULL; node_name = xmlfn_nextnode( name ) ){
		print_all_props( node_name, tabs );
		printf("\n");
		print_curr_node();
	}
	xmlfn_stepout( NULL );
	return;
}

void print_value_name( char *name)
{
	char *node_name;
	int tabs= xmlfn_stepin();
	for(node_name = xmlfn_nextnode( name ) ; node_name != NULL; node_name = xmlfn_nextnode( name ) ){ //
//		print_all_props( node_name, tabs );
		printf( "Value = %s ",xmlfn_getcontent(NULL));
		printf(" id = %s overstep = %s\n",xmlfn_getprop("id"), xmlfn_getprop("overstep"));
	}
	xmlfn_stepout( NULL );
	return;
}

int test( const char *filename )
{
	int fd = open( filename, O_RDONLY );
	int exit_code = 0;
	if( fd < 0 ){
		printf( "%s error: can't open xml document %s", __FILE__, filename );
		return -1;
	}
	if(( exit_code = xmlfn_init( fd )) == 0 ){
		char *node_name = NULL;
		for( node_name = xmlfn_nextnode( NULL ); node_name != NULL; node_name = xmlfn_nextnode( NULL )){
			print_all_props( node_name, 0 );
			print_curr_node();
		}
	}
	printf("\n\n");
	if(( exit_code = xmlfn_reinit()) == 0 ){
		char *node_name = NULL;
		if( (node_name = xmlfn_nextnode( "model")) != NULL ){
			print_all_props( node_name, 0 );
			printf("\n");
			print_value_name("loadmodule");
		}
	}
/*	printf("\n\n");
	if(( exit_code = xmlfn_reinit()) == 0 ){
		char *node_name = NULL;
		if( (node_name = xmlfn_nextnode( "model")) != NULL ){
			print_all_props( node_name, 0 );
			print_node_name("object");
		}
	}
*/
	xmlfn_free();
	close( fd );
	return exit_code;
}

int main( int argc, char **argv )
{
	if( argc <= 1 || argc > 2 )
		return usage();
	return test( argv[1] );
}
