#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "getparam.m"
#include "../../engine/nce_common.h"

unsigned int number_of_channel = 0;
int NChannels = -1;
datum *dataframe = NULL;
int *MarkCh = NULL;
ssize_t web_read  (int FILEDES, const void *BUFFER, size_t SIZE)
{
	size_t counter = 0; 
	ssize_t result;
	while(counter < SIZE) {
		if( (result = read(FILEDES, (const void *)((char*)BUFFER + counter), SIZE - (size_t) counter)) <= 0)
			return EOF;
		else counter += (size_t)result;
	}
	return counter;
}

int header_1(int fd){
	int ids[2], mark, cnt, fl = 0;
	double period = 0.0;
	printf("\t<==========  Watcher Header  ===========>\n");
	if( web_read(fd, ids, sizeof( int ) * 2) != sizeof( int ) * 2){
		printf("Cannot web_read wid and pid\n");
		exit(6);
	}
	printf("\tWatcher ID:\t\t\t%d\n",ids[0]);
	printf("\tProcess ID:\t\t\t%d\n",ids[1]);
	if( web_read(fd, &period, sizeof(double)) != sizeof(double) ){
		printf("Cannot web_read Watcher Period\n");
		exit(7);
	}
	printf("\tUpdate Period:\t\t\t%lf\n",period);
	if( web_read(fd, &number_of_channel, sizeof (int)) != sizeof( int ) ){
		printf("Cannot web_read numer of watcherd variable\n");
		exit(8);
	}
	printf("\tNumber of Watchred Variable:\t%d\n",number_of_channel);
	if( NChannels <= 0){
		MarkCh = (int*)malloc((NChannels = number_of_channel) * sizeof(int));
		for(mark=0; mark<NChannels; mark++) MarkCh[mark] = mark;
	}
	else{
		for(mark=0; mark<NChannels; mark++)
			if((MarkCh[mark] < 0)||(MarkCh[mark] >= number_of_channel)) MarkCh[mark]=mark;
	}
	if(dataframe != NULL) free(dataframe);
	if( (dataframe = (datum*) malloc(sizeof( datum) * number_of_channel) ) == NULL){
		printf("Cannot malloc memory for data frame!\n", cnt);
		exit(7);
	}
	
	printf("\t<============ Channel Map ==============>\n");
	for(cnt=0; cnt < number_of_channel; cnt++, fl = 0){
		if( web_read(fd,ids,sizeof(int) * 2) != sizeof(int) * 2){
			printf("Cannot web_read oid and nid in %d\n", cnt);
			exit(6);
		}
		printf("\t%03d\t% 6d\t% 6d\t",cnt,ids[0],ids[1]);
		for(mark=0; (mark<NChannels)&&(!fl); mark++){
			if (cnt == MarkCh[mark]){
				fl = 1;
				printf("\t* % 3d *\n",mark);
			}
		}
		if(!fl){
			printf("\t-------\n");
		}
	}
	printf("\t<=======================================>\n");
	return 0;
}

int main(int csc, char **vv)
{
	char *pWBFFileName = NULL;
	char *pBinFileName = NULL;
	int citem=0;
	int mark;
	char chmark[10];
	double bt = 0.0, et = -1.0, af=1.0;
	for(citem=0; citem<csc; citem++){
		__FIND_PS__(vv[citem],"if=",pWBFFileName);
		__FIND_PS__(vv[citem],"of=",pBinFileName);
		__FIND_LF__(vv[citem],"bt=",bt);
		__FIND_LF__(vv[citem],"et=",et);
		__FIND_LF__(vv[citem],"af=",af);
		__FIND_D__(vv[citem],"ch=",NChannels);
		if((NChannels > 0)&&(MarkCh == NULL)){
			MarkCh = (int*)malloc(NChannels * sizeof(int));
			for(mark=0; mark<NChannels; mark++)	MarkCh[mark]=-1;
		}
		for(mark=0; mark<NChannels; mark++){
			memset(chmark,0,10);
			snprintf(chmark,10,"%d=\0",mark);
			__FIND_D__(vv[citem],chmark,MarkCh[mark]);
		}
	}
	if( (pWBFFileName == NULL) || (pBinFileName == NULL) ){
		printf("Use %s(wbftobin wbf2bin w2t) if=<input wbf file> of=<output text file> ch=<number of channels in bin file>\n"
			"\t after ch= you can set 1=<number of channel in wbf file for fist channel in bin>\n"
			"\t bt=<time for beginig> et=<end time> of convertions\n"
			"\t af=<amplitude coefficient> default by 1.0\n",vv[0]);
		return 1;
	}
	int hInFile = open(pWBFFileName, O_RDONLY, NULL);
	if(hInFile == -1){
		printf("Cannot open file: %s\n", pWBFFileName);
		return 1;
	}
	int hOutFile = open(pBinFileName, O_CREAT | O_RDWR, S_IRUSR| S_IWUSR );
	if(hOutFile == -1){
		printf("Cannot open or create file: %s\n", pBinFileName);
		return 2;
	}
	printf("\n%s covector\n\t>\n",vv[0]);
	printf("\tWBF: %s\n",pWBFFileName);
	printf("\tBIN: %s\n",pBinFileName);
	int hmark = 0;
	if ( web_read(hInFile,&hmark, sizeof(int)) != sizeof(int) ){
		printf("Cannot find header of wbf file. %s is currapt\n", pWBFFileName);
		return 3;
	}
	else{
		if(hmark < 0)
			switch(hmark){
				case -1: 
					if(header_1(hInFile) < 0) return 5;
					break;
				default:
					printf("!!!\tHeader of %s has unsupported type<1>\n", pWBFFileName);
					return 4;
					break;
			}
	}
		
	char Ft[]="/-\\|"; int Ftc=0;
	int endflag = 1, ids[2];
	double time;
	short dt[NChannels];
	memset(dt,0, sizeof(short)*NChannels);
	struct flock outlock;
	memset(&outlock, 0, sizeof(outlock));
	while(endflag){
		outlock.l_type=F_WRLCK;
		fcntl(hInFile,F_SETLKW,&outlock);
		
		if(endflag){
			if ( web_read(hInFile,&hmark, sizeof(int)) != sizeof(int) ) endflag = 0;
			else{
				if(hmark < 0)
					switch(hmark){
						case -1: 
							if(header_1(hInFile) < 0) return 5;
							break;
						default:
							outlock.l_type=F_UNLCK;
							fcntl(hInFile,F_SETLKW,&outlock);
							printf("!!!\tHeader of %s has unsupported type\n", pWBFFileName);
							return 4;
							break;
					}
			}
		}

		if( (endflag) && ( web_read(hInFile,ids, sizeof(int) * 2) != sizeof(int) * 2 ) ) endflag = 0;
		if( (endflag) && ( web_read(hInFile,&time, sizeof(double) ) != sizeof(double) ) ) endflag = 0;
		if( (endflag) && ( web_read(hInFile,dataframe, sizeof( datum) * number_of_channel) != sizeof( datum) * number_of_channel ) ) endflag = 0;
		
		outlock.l_type=F_UNLCK;
		fcntl(hInFile,F_SETLKW,&outlock);

		for(mark=0; mark<NChannels; mark++)
			dt[mark] = (short)(dataframe[MarkCh[mark]] * af);
		write(hOutFile,&dt,sizeof(short)*NChannels);
		if(!(hmark%100))
			fprintf(stderr,"\t\t<%d:%d :: %lf[%d]  %c>\r",ids[0],ids[1],time,hmark,Ft[Ftc = (Ftc+1)&0x3]);
	}
	close(hInFile);
	close(hOutFile);
	free(MarkCh);
	printf("\r\t<           Complite Convertion!        >\n");
	return 0;
}

