#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "getparam.m"
#include <neurocad/engine/nce_common.h>

unsigned int number_of_channel = 0;
int NChannels = -1;
datum *dataframe = NULL;
int *MarkCh = NULL;
FILE *Consol = NULL;
ssize_t web_read  (int FILEDES, const void *BUFFER, size_t SIZE)
{
	size_t counter = 0; 
	ssize_t result;
	while(counter < SIZE) {
		if( (result = read(FILEDES, (const void *)((char*)BUFFER + counter), SIZE - (size_t) counter)) <= 0)
			return EOF;
		else counter += (size_t)result;
	}
	return counter;
}
int header_1(int fd){
	int ids[2], mark, cnt, fl = 0;
	double period = 0.0;
//	if (Consol != NULL ) fprintf(Consol, "\t<========  SLEPPING for FIFO  ==========>\r");
//	sleep(3);
	if (Consol != NULL ) fprintf(Consol,"\t<==========  Watcher Header  ===========>\n");
	if( web_read(fd, ids, sizeof( int ) * 2) != sizeof( int ) * 2){
		if (Consol != NULL ) fprintf(Consol,"Cannot web_read wid and pid\n");
		exit(6);
	}
	if (Consol != NULL ) fprintf(Consol,"\tWatcher ID:\t\t\t%d\n",ids[0]);
	if (Consol != NULL ) fprintf(Consol,"\tProcess ID:\t\t\t%d\n",ids[1]);
	if( web_read(fd, &period, sizeof(double)) != sizeof(double) ){
		if (Consol != NULL ) fprintf(Consol,"Cannot web_read Watcher Period\n");
		exit(7);
	}
	if (Consol != NULL ) fprintf(Consol,"\tUpdate Period:\t\t\t%lf\n",period);
	if( web_read(fd, &number_of_channel, sizeof (int)) != sizeof( int ) ){
		if (Consol != NULL ) fprintf(Consol,"Cannot web_read numer of watcherd variable\n");
		exit(8);
	}
	if (Consol != NULL ) fprintf(Consol,"\tNumber of Watchred Variable:\t%d\n",number_of_channel);
	if( NChannels <= 0){
		MarkCh = (int*)malloc((NChannels = number_of_channel) * sizeof(int));
		for(mark=0; mark<NChannels; mark++) MarkCh[mark] = mark;
	}
	else{
		for(mark=0; mark<NChannels; mark++)
			if((MarkCh[mark] < 0)||(MarkCh[mark] >= number_of_channel)) MarkCh[mark]=mark;
	}
	if(dataframe != NULL) free(dataframe);
	if( (dataframe = (datum*) malloc(sizeof( datum) * number_of_channel) ) == NULL){
		if (Consol != NULL ) fprintf(Consol,"Cannot malloc memory for data frame!\n", cnt);
		exit(7);
	}
	
	if (Consol != NULL ) fprintf(Consol,"\t<============ Channel Map ==============>\n");
	for(cnt=0; cnt < number_of_channel; cnt++, fl = 0){
		if( web_read(fd,ids,sizeof(int) * 2) != sizeof(int) * 2){
			if (Consol != NULL ) fprintf(Consol,"Cannot web_read oid and nid in %d\n", cnt);
			exit(6);
		}
		if (Consol != NULL ) fprintf(Consol,"\t%03d\t% 6d\t% 6d\t",cnt,ids[0],ids[1]);
		for(mark=0; (mark<NChannels)&&(!fl); mark++){
			if (cnt == MarkCh[mark]){
				fl = 1;
				if (Consol != NULL ) fprintf(Consol,"\t* % 3d *\n",mark);
			}
		}
		if(!fl){
			if (Consol != NULL ) fprintf(Consol,"\t-------\n");
		}
	}
	if (Consol != NULL ) fprintf(Consol,"\t<=======================================>\n");
	return 0;
}

int main(int csc, char **vv)
{
	char *pWBFFileName = NULL;
	char *pTxtFileName = NULL;
	int hInFile = -1;
	FILE *hOutFile = NULL;
	int citem=0;
	int mark;
	char chmark[10];
	double bt = 0.0, et = -1.0;
	for(citem=0; citem<csc; citem++){
		__FIND_PS__(vv[citem],"if=",pWBFFileName);
		__FIND_PS__(vv[citem],"of=",pTxtFileName);
		__FIND_LF__(vv[citem],"bt=",bt);
		__FIND_LF__(vv[citem],"et=",et);
		__FIND_D__(vv[citem],"ch=",NChannels);
		if((NChannels > 0)&&(MarkCh == NULL)){
			MarkCh = (int*)malloc(NChannels * sizeof(int));
			for(mark=0; mark<NChannels; mark++)	MarkCh[mark]=-1;
		}
		for(mark=0; mark<NChannels; mark++){
			memset(chmark,0,10);
			snprintf(chmark,10,"%d=\0",mark);
			__FIND_D__(vv[citem],chmark,MarkCh[mark]);
		}
		if( (!strcmp(vv[citem],"--help")) || (!strcmp(vv[citem],"-h")) ){
			fprintf(stderr,"Use %s(wbftotxt wbf2txt w2t) if=<input wbf file> of=<output text file> ch=<number of channels in txt file>\n"
				"\t after ch= you can set 1=<number of channel in wbf file for fist channel in txt>\n"
				"\t bt=<time for beginig> et=<end time> of convertions\n",vv[0]);
			return 0;
		}
	}
	if( pWBFFileName == NULL ){
		hInFile = 0;
	}
	else if( (hInFile = open(pWBFFileName, O_RDONLY, NULL)) == -1){
		fprintf(stderr,"Cannot open file: %s\n", pWBFFileName);
		return 1;
	}
	if( pTxtFileName == NULL ) {
		if( (hOutFile = fdopen(1,"w")) == NULL){
			fprintf(stderr,"Cannot open snadart ouput: \n");
			return 2;
		}
	}
	else
		if( (hOutFile = fopen(pTxtFileName, "w+") ) == NULL){
			fprintf(stderr,"Cannot open or create file: %s\n", pTxtFileName);
			return 2;
		}
		else
			Consol = fdopen(1,"w");

	if (Consol != NULL ) fprintf(Consol,"\n%s covector\n\t>\n",vv[0]);
	if (Consol != NULL ) fprintf(Consol,"\tWBF: %s\n",pWBFFileName);
	if (Consol != NULL ) fprintf(Consol,"\tTXT: %s\n",pTxtFileName);
	int hmark = 0;
	if ( web_read(hInFile,&hmark, sizeof(int)) != sizeof(int) ){
		if (Consol != NULL ) fprintf(Consol,"Cannot find header of wbf file. %s is currapt\n", pWBFFileName);
		return 3;
	}
	else{
		if(hmark < 0)
			switch(hmark){
				case -1: 
					if(header_1(hInFile) < 0) return 5;
					break;
				default:
					if (Consol != NULL ) fprintf(Consol,"!!!\tHeader of %s has unsupported type\n", pWBFFileName);
					return 4;
					break;
			}
	}
		
	char Ft[]="/-\\|"; int Ftc=0;
	int endflag = 1, ids[2];
	double time;
	struct flock outlock;
	memset(&outlock, 0, sizeof(outlock));
	while(endflag){
		outlock.l_type=F_WRLCK;
		fcntl(hInFile,F_SETLKW,&outlock);
		if(endflag){
			if ( web_read(hInFile,&hmark, sizeof(int)) != sizeof(int) ) endflag = 0;
			else{
				if(hmark < 0)
					switch(hmark){
						case -1: 
							if(header_1(hInFile) < 0) return 5;
							break;
						default:
							outlock.l_type=F_UNLCK;
							fcntl(hInFile,F_SETLKW,&outlock);
							if (Consol != NULL ) fprintf(Consol,"!!!\tHeader of %s has unsupported type\n", pWBFFileName);
							return 4;
							break;
					}
			}
		}

		if( (endflag) && ( web_read(hInFile,ids, sizeof(int) * 2) != sizeof(int) * 2 ) ) endflag = 0;
		if( (endflag) && ( web_read(hInFile,&time, sizeof(double) ) != sizeof(double) ) ) endflag = 0;
		if( (endflag) && ( web_read(hInFile,dataframe, sizeof( datum) * number_of_channel) != sizeof( datum) * number_of_channel ) ) endflag = 0;
		
		outlock.l_type=F_UNLCK;
		fcntl(hInFile,F_SETLKW,&outlock);

		fprintf(hOutFile,"%lf",time);
		for(mark=0; mark<NChannels; mark++)
			fprintf(hOutFile,"\t%lg",dataframe[MarkCh[mark]]);
		fprintf(hOutFile,"\n");
		if(!(hmark%100))
			fprintf(stderr,"\t\t<%d:%d :: %lf[%d]  %c>\r",ids[0],ids[1],time,hmark,Ft[Ftc = (Ftc+1)&0x3]);
	}
	close(hInFile);
	fclose(hOutFile);
	free(MarkCh);
	if (Consol != NULL ) fprintf(Consol,"\r\t<           Complite Convertion!        >\n");
	return 0;
}
