#ifndef MEMMANAGER_H
#define MEMMANAGER_H

#include <sys/types.h>
#include <neurocad/engine/nce_common.h>

/**
This functions alow account the mempry if several engine
running in one shared memory. Use it beside classical malloc and free!!!
**/
void	*mem_malloc(size_t size);
void	 mem_free(void *ptr);

/**
The Granular mechanisms of memory reduces the number of system memory handles.
Initiated by mem_g_init() larg memory area (called granule) is allocated by
mem_g_malloc() and released as one piece by mem_g_release().
Use it for model allocated, fifo and stacks, buffers for synapsys delay, etc.
**/
void	*mem_g_init (size_t allsize);
void	*mem_g_malloc(void *handle, size_t size);
int	 mem_g_release(void *handle);
void	*mem_g_resize(void *handle, size_t newsize);
size_t	 mem_g_getfreesize(void *handle);

/**
mem_printinfo() print out information about used memory 
Always returns 0.
**/
int	mem_printinfo();

/**
mem_g_dbdump() print out HEX gramule dump and sevral information about granul
Use it for debug.
**/
void	mem_g_dbdump(void *handle);

#endif

