#ifndef SIMMANAGER_H
#define SIMMANAGER_H

#include <neurocad/module.h>
#include <neurocad/engine/modmanager.h>
#include <neurocad/engine/watchmanager.h>

/**
The two common variables nce_time_cur and nce_time_step are containing model time
and time step of equation solutions.
**/
extern datum nce_time_cur, nce_time_step;

/**
The nce_bufdeep is set of buffer size for all named variables. The nce_sw and nce_asw
(pronounce switch and anti-switch) point on data for current step and next step
resepctively.
 **/
extern int nce_sw, nce_asw, nce_bufdeep;

/**
The sim_flag is simulation falg. The simulation is doing the flag set in fure (one).
If you woudle like to stop simulation drop this flag in zero.
 **/
extern sig_atomic_t sim_flag;

/**
Initial setup of simulation manager. Function sim_init() must call after all modules 
are insered. Return an error (number under zero) or zero.
 **/
int sim_init();

/**
Release of simualtion scheduler.
 **/
int sim_free();

/**
The sim_step() runs one step of simulation.
 **/
int sim_step();


/**
The sim_start() runs the simulation while the model time less then continueTime
 **/
int sim_start(datum continueTime);

/**
The sim_go() runs the simulation through numberSteps.
 **/
int sim_go(int numberSteps);

/**
The sim_until() runs the simulation until the model time less then untilTime
 **/
int sim_until(datum untilTime);

/**
Stop simualtion.
 **/
int sim_stop();

/**
Next thre functions is used for debug modules. First takes a one iteration of current
scheduler item and return. The sim_db_mod_iter runs simulation until it found iteration
of module with mid and stop before. The last runs through scheduler before found the module
with mid equal the current.
 **/
int sim_db_iter();
int sim_db_mod_iter(int mid);
int sim_db_next_mod_iter();

/**
The function sim_printinfo() prints out the information about simulation manager and returns.
 **/
int sim_printinfo();

#endif
